Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0039163
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Openbravo ERP] 04. Warehouse managementminoralways2018-08-21 10:522019-03-28 14:55
ReportervmromanosView Statuspublic 
Assigned ToAtulOpenbravo 
PrioritynormalResolutionfixedFixed in Version3.0PR19Q2
StatusclosedFix in branchFixed in SCM revision0906b858ed6e
ProjectionnoneETAnoneTarget Version
OSAnyDatabaseAnyJava version
OS VersionDatabase versionAnt version
Product VersionSCM revision 
Review Assigned Todmiguelez
Web browser
ModulesCore
Regression level
Regression date
Regression introduced in release
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0039163: QueryTimeoutException is no longer thrown in Oracle after Hibernate 5.3 upgrade

DescriptionIn case of exceptions thrown by triggers in Oracle before Hibernate upgrade they were thrown as QueryTimeoutException. However after Hibernate upgrade it is used GenericJDBCException instead (exactly the same as in PostgreSQL).

In InventoryCountProcess there is a catch block that differentiate between PG and Oracle. After Hibernate upgrade there is no need to differentiate anymore, but also we need to make sure the exception message is properly thrown in both databases.

Similar use of QueryTimeoutException could be also found in
1. VariantChDescUpdateProcess.java
2. VariantAutomaticGenerationProcess
Steps To ReproduceTo force a trigger exception, open the M_TRANSACTION_TRG2 and throw an exception at the beginning of the trigger. Example:
RAISE_APPLICATION_ERROR(-20000, '@CannotUseGenericProduct@');

Login as Openbravo Admin
Open Physical Inventory window.
Create a header.
Create a line and select any product.
Modify the qty (for example add one unit).
Process the record.
The exception is thrown.
Verify the message is properly shown in both Oracle and PG.
Proposed SolutionAttached proposed solution
TagsNo tags attached.
Attached Filesdiff file icon pg_ora_invcount.diff [^] (3,149 bytes) 2018-08-21 10:52 [Show Content]

- Relationships Relation Graph ] Dependency Graph ]
related to feature request 0037064 closedcaristu upgrade hibernate 
related to defect 00391493.0PR18Q4 closedTriage Finance Error message thrown by Oracle trigger after Hibernate upgrade [Oracle only] 

-  Notes
(0106590)
AtulOpenbravo (developer)
2018-09-04 09:00

Test Plan

- To force a trigger exception, open the M_TRANSACTION_TRG2 and throw an exception at the beginning of the trigger. Example:

  RAISE_APPLICATION_ERROR(-20000, '@CannotUseGenericProduct@');

- Login as Openbravo Admin
- Open Physical Inventory window.
- Create a header.
- Create a line and select any product.
- Modify the qty (for example add one unit).
- Process the record.
- The exception is thrown.
- Verify the message is properly shown in both Oracle and PG.
(0108143)
AtulOpenbravo (developer)
2018-11-28 11:13
edited on: 2018-11-28 11:18

Test Plan

- To force a trigger exception, open the m_product_bef_trg and throw an exception at the beginning of the trigger. Example:

RAISE EXCEPTION '%', '@20009@'; --OBTG:-20000--

- Configure workspace in eclipse and start tomcat in debug mode.
- Add breakpoint in VariantAutomaticGenerationProcess class for try catch blocks for
  i. GenericJDBCException
  ii. QueryTimeoutException
  iii. Exception
- Login as F&B International Group Admin
- Create a Product Characteristic For eg: Color
- Create two values under it. For eg: Red, Blue.
- Create a Generic Product "Shirts" under a organization.
- Run Create Variants process.
- Realize that execution on process enters the Exception catch block.

(0108144)
AtulOpenbravo (developer)
2018-11-28 11:18
edited on: 2018-11-28 12:26

Test Plan

- To force a trigger exception, open the m_product_bef_trg and throw an exception at the beginning of the trigger. Example:

RAISE EXCEPTION '%', '@20009@'; --OBTG:-20000--

- Configure workspace in eclipse and start tomcat in debug mode.
- Add breakpoint in VariantChDescUpdateProcess class for try catch blocks for
  i. GenericJDBCException
  ii. QueryTimeoutException
  iii. Exception
- Login as F&B International Group Admin
- Run Update Product Characteristics Description process.
- Select any product from the price list - Tarifa de ventas. For eg: Vino Blanca
- Realize that execution on process enters the Exception catch block.

(0108977)
hgbot (developer)
2019-01-16 11:48

Repository: erp/devel/pi
Changeset: 0906b858ed6e5d80adc88c35c2148b650bbc9879
Author: David Miguelez <david.miguelez <at> openbravo.com>
Date: Thu Nov 22 17:36:26 2018 +0100
URL: http://code.openbravo.com/erp/devel/pi/rev/0906b858ed6e5d80adc88c35c2148b650bbc9879 [^]

Fixes Issue 0039163:QueryTimeoutException is no longer
thrown in Oracle after Hibernate 5.3 upgrade

** Use split to show proper message in catch block
for GenericJDBCException.
** Catch block for QueryTimeOutException not required any longer.

---
M src/org/openbravo/materialmgmt/InventoryCountProcess.java
M src/org/openbravo/materialmgmt/VariantAutomaticGenerationProcess.java
M src/org/openbravo/materialmgmt/VariantChDescUpdateProcess.java
---
(0108988)
dmiguelez (developer)
2019-01-17 09:29

Code Review + Testing Ok
(0110732)
hudsonbot (developer)
2019-03-28 14:55

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/b2fbc1588df4 [^]
Maturity status: Test

- Issue History
Date Modified Username Field Change
2018-08-21 10:52 vmromanos New Issue
2018-08-21 10:52 vmromanos Assigned To => Triage Finance
2018-08-21 10:52 vmromanos File Added: pg_ora_invcount.diff
2018-08-21 10:52 vmromanos Modules => Core
2018-08-21 10:52 vmromanos Triggers an Emergency Pack => No
2018-08-21 10:53 vmromanos Relationship added related to 0037064
2018-08-21 13:11 caristu Relationship added related to 0039149
2018-08-21 21:05 AtulOpenbravo Status new => scheduled
2018-08-30 20:45 AtulOpenbravo Description Updated View Revisions
2018-09-04 09:00 AtulOpenbravo Note Added: 0106590
2018-11-28 11:13 AtulOpenbravo Note Added: 0108143
2018-11-28 11:14 AtulOpenbravo Note Edited: 0108143 View Revisions
2018-11-28 11:18 AtulOpenbravo Note Added: 0108144
2018-11-28 11:18 AtulOpenbravo Note Edited: 0108143 View Revisions
2018-11-28 12:26 AtulOpenbravo Note Edited: 0108144 View Revisions
2019-01-16 11:48 hgbot Checkin
2019-01-16 11:48 hgbot Note Added: 0108977
2019-01-16 11:48 hgbot Status scheduled => resolved
2019-01-16 11:48 hgbot Resolution open => fixed
2019-01-16 11:48 hgbot Fixed in SCM revision => http://code.openbravo.com/erp/devel/pi/rev/0906b858ed6e5d80adc88c35c2148b650bbc9879 [^]
2019-01-17 09:29 dmiguelez Review Assigned To => dmiguelez
2019-01-17 09:29 dmiguelez Note Added: 0108988
2019-01-17 09:29 dmiguelez Status resolved => closed
2019-01-17 09:29 dmiguelez Fixed in Version => 3.0PR19Q2
2019-01-18 08:29 dmiguelez Assigned To Triage Finance => AtulOpenbravo
2019-03-28 14:55 hudsonbot Checkin
2019-03-28 14:55 hudsonbot Note Added: 0110732


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker